var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('angular2/core');
var Prism = require('prism/prism');
require('prism/components/prism-bash');
require('prism/components/prism-powershell');
require('prism/components/prism-javascript');
Prism.languages.undefined = {};
require('prism/plugins/line-numbers/prism-line-numbers');
require('prism/plugins/command-line/prism-command-line');
require('prism/plugins/normalize-whitespace/prism-normalize-whitespace');
var TEMPLATE_REGEX = /<!--template\sbindings={[^\}]*}-->/g;
var CodeRenderer = (function () {
    function CodeRenderer(_renderer) {
        this._renderer = _renderer;
    }
    CodeRenderer.prototype.render = function () {
        this._replaceCode();
        this._highlight();
    };
    CodeRenderer.prototype.empty = function () {
        if (this._pre) {
            this._pre.innerHTML = "";
        }
    };
    CodeRenderer.prototype._replaceCode = function () {
        this._renderer.setElementProperty(this._pre.nativeElement, 'innerHTML', this._buildCodeElement());
    };
    CodeRenderer.prototype._highlight = function () {
        Prism.highlightElement(this._pre.nativeElement.querySelector('code'), false, null);
    };
    Object.defineProperty(CodeRenderer.prototype, "_processedCode", {
        get: function () {
            return this._isMarkup(this.language) ? this._processMarkup(this.code) : this.code;
        },
        enumerable: true,
        configurable: true
    });
    CodeRenderer.prototype._processMarkup = function (text) {
        return this._replaceTags(this._removeAngularMarkup(text));
    };
    CodeRenderer.prototype._replaceTags = function (text) {
        return text.replace(/(<)([!\/A-Za-z].*?>)/g, '&lt;$2');
    };
    CodeRenderer.prototype._removeAngularMarkup = function (html) {
        html = html.replace(/\s_ng[^-]+-[^-]+-[^=]+="[^"]*"/g, '');
        var lines = this._fixIndentation(html);
        lines = lines.filter(function (line) {
            if (line.trim() === '') {
                return true;
            }
            var replaced = line.replace(TEMPLATE_REGEX, '').trim();
            return replaced !== '';
        });
        html = lines.join("\n");
        return html.replace(TEMPLATE_REGEX, '');
    };
    CodeRenderer.prototype._isMarkup = function (language) {
        return language === 'markup' || language === 'markdown';
    };
    CodeRenderer.prototype._buildCodeElement = function () {
        return "<code class=\"" + this.codeClasses + "\">" + this._processedCode + "</code>";
    };
    Object.defineProperty(CodeRenderer.prototype, "languageClass", {
        get: function () {
            return 'language-' + this.language;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CodeRenderer.prototype, "lineNumbersClass", {
        get: function () {
            return this.lineNumbers ? "line-numbers " : "";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CodeRenderer.prototype, "shellClass", {
        get: function () {
            return this.shell ? "command-line" : "";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CodeRenderer.prototype, "codeClasses", {
        get: function () {
            return this.languageClass + " " + this.language;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CodeRenderer.prototype, "preClasses", {
        get: function () {
            return this.lineNumbersClass + ' ' + this.languageClass + ' ' + this.shellClass;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CodeRenderer.prototype, "_codeEl", {
        get: function () {
            return this._pre.querySelector('code');
        },
        enumerable: true,
        configurable: true
    });
    CodeRenderer.prototype._fixPromptOutputPadding = function () {
        var promptWidth = this._codeEl.querySelector('.command-line-prompt').clientWidth;
        var prePadding = parseInt(this._getStyle(this._pre, 'padding-left').replace('px', ''), 10);
        this._pre.style.paddingRight = (2 * prePadding + promptWidth / 2) + 'px';
    };
    CodeRenderer.prototype._getStyle = function (oElm, strCssRule) {
        var strValue = "";
        if (document.defaultView && document.defaultView.getComputedStyle) {
            strValue = document.defaultView.getComputedStyle(oElm, "").getPropertyValue(strCssRule);
        }
        else if (oElm.currentStyle) {
            strCssRule = strCssRule.replace(/\-(\w)/g, function (strMatch, p1) {
                return p1.toUpperCase();
            });
            strValue = oElm.currentStyle[strCssRule];
        }
        return strValue;
    };
    CodeRenderer.prototype._fixIndentation = function (html) {
        var indent = 0;
        var diff = 0;
        var removeLines = [];
        var lines = html.split("\n").map(function (line, index) {
            if (line.trim() === '') {
                if (indent > 0) {
                    removeLines.push(index);
                }
                indent = 0;
                return '';
            }
            var a = line.replace(TEMPLATE_REGEX, '').trim();
            if (a === '') {
                indent = line.match(/^\s*/)[0].length;
                return line;
            }
            else if (indent > 0) {
                length = line.match(/^\s*/)[0].length;
                if (diff === 0) {
                    diff = length - indent;
                }
                if (length >= indent) {
                    return line.slice(diff);
                }
                else {
                    indent = 0;
                }
            }
            return line;
        });
        removeLines.forEach(function (removalIndex) {
            lines.splice(removalIndex, 1);
        });
        return lines;
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], CodeRenderer.prototype, "code", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], CodeRenderer.prototype, "language", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], CodeRenderer.prototype, "lineNumbers", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], CodeRenderer.prototype, "shell", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], CodeRenderer.prototype, "prompt", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], CodeRenderer.prototype, "outputLines", void 0);
    __decorate([
        core_1.ViewChild('preEl'), 
        __metadata('design:type', Object)
    ], CodeRenderer.prototype, "_pre", void 0);
    CodeRenderer = __decorate([
        core_1.Component({
            selector: 'code-renderer',
            template: "\n    <pre #preEl [class]=\"preClasses\"\n      [attr.data-prompt]=\"prompt\"\n      [attr.data-output]=\"outputLines\"\n    ></pre>\n  "
        }), 
        __metadata('design:paramtypes', [core_1.Renderer])
    ], CodeRenderer);
    return CodeRenderer;
})();
exports.CodeRenderer = CodeRenderer;
